var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Color, TimeString, NameCase } from "ht-utility";
import { CurrentUser } from "./current-user";
import { MapItemsMixin } from "../mixins/map-items";
import { MarkersMixin } from "../mixins/marker-renderer";
import { StyleMixin } from "../mixins/styles";
import { TraceMixin } from "../mixins/trace";
import { PopupMixin } from "../mixins/popup-renderer";
import { SingleItemMixin } from "../mixins/single-item";
import { CircleMixin } from "../mixins/circle-renderer";
var ReplayMarker = (function (_super) {
    __extends(ReplayMarker, _super);
    function ReplayMarker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = "replay marker";
        _this.styleObj = {
            default: {
                radius: 6,
                fillColor: Color.greenDark,
                fillOpacity: 1,
                weight: 2,
                color: 'black',
                pane: "markerPane"
            },
            popup: {
                offset: [0, -5],
                // offset: point(0, -5),
                closeButton: false
            },
            highlight: {
                radius: 10,
                fillColor: Color.stop,
                fillOpacity: 1,
                weight: 4,
                color: Color.stopDark,
                pane: "markerPane"
            },
            fade: {
                radius: 10,
                fillColor: Color.stop,
                fillOpacity: 0.1,
                weight: 2,
                color: Color.stopDark,
                pane: "markerPane"
            }
        };
        return _this;
    }
    ReplayMarker.prototype.getPosition = function (data) {
        return data.currentPosition;
    };
    ;
    ReplayMarker.prototype.getBearing = function (data) {
        return data.bearing;
    };
    ReplayMarker.prototype.getInfoContent = function (data) {
        var time = "<div class=\"has-text-weight-bold\">" + TimeString(data.currentTime) + "</div>";
        var activity = data.currentSegment ? "<div>" + NameCase(data.currentSegment.type) + "</div>" : "";
        return "<div class=\"flex-column justify-center text-center\">" + time + activity + "</div>";
    };
    return ReplayMarker;
}(CurrentUser));
export { ReplayMarker };
;
export var ReplayMarkerTrace = SingleItemMixin(CircleMixin(PopupMixin(TraceMixin(MarkersMixin(StyleMixin(MapItemsMixin(ReplayMarker)))))));
// import {SetMap} from "../../utils/map-utls";
// import {Color} from "../../utils/color";
// import {HtMarkerItem} from "./ht-js-map/marker-item";
// import {divIcon, marker} from "leaflet";
//
//
// export class ReplayMarker extends HtMarkerItem {
//     item: L.Marker = marker([0,0], {
//         pane: 'popupPane',
//         zIndexOffset: 110
//     });
//     test = marker([0,0]);
//
//     setPositionBearing(position, bearing, map) {
//         this.setIcon(bearing);
//         this.item.setLatLng(position);
//         SetMap(this.item, map)
//     }
//
//     private getIcon(bearing: number = 0): L.DivIcon {
//         return divIcon({
//             html: this.getDivContent(bearing),
//             className: 'current-user-marker',
//             iconSize: [50, 50]
//         })
//     }
//
//     private setIcon(bearing: number = 0) {
//         this.item.setIcon(this.getIcon(bearing))
//     }
//
//     private getDivContent(bearing: number): string {
//         let icon = `<div id="user-marker" style="opacity: 0.7">
// <div class="marker">  <svg style="transform: rotateZ(${bearing}deg) scale(0.83)" fill="${Color.blueDark}" viewBox="0 0 96 96"><g><path style="; stroke-width: 4px" d="M51.58,19.16l27.15,54.3a4,4,0,0,1-5.33,5.39l-24.6-12a4,4,0,0,0-3.58,0L22.88,78.41a4,4,0,0,1-5.41-5.35l27-53.9A4,4,0,0,1,51.58,19.16Z"/></g></svg></div>
// </div>`;
//         return icon
//     }
// }
//# sourceMappingURL=replay.marker.js.map