import { GoogleMapUtilsClass } from "ht-google-maps-wrapper";
import { LeafletMapUtilsClass } from "ht-leaflet-wrapper";
export var mapTypeService = (function () {
    var instance;
    var currentmapType;
    function getMapType(mapType) {
        switch (mapType) {
            case 'leaflet': {
                return new LeafletMapUtilsClass();
            }
            case 'google': {
                return new GoogleMapUtilsClass();
            }
            default: {
                return new GoogleMapUtilsClass();
            }
        }
    }
    return {
        getInstance: function (mapType) {
            if (!instance || !currentmapType) {
                currentmapType = mapType;
                instance = getMapType(mapType);
            }
            return instance;
        }
    };
})();
//# sourceMappingURL=map-type.js.map