import { TraceMixin } from "../mixins/trace";
import { PolylinesMixin } from "../mixins/polyline-renderer";
import { MapItemsMixin } from "../mixins/map-items";
import { StyleMixin } from "../mixins/styles";
import { Color } from "ht-utility";
var StopsPolyline = (function () {
    function StopsPolyline(mapInstance) {
        this.mapInstance = mapInstance;
        this.name = "stop polyline";
        this.styleFunct = {
            get: function (type) {
                switch (type) {
                    case "google":
                        {
                            return {
                                default: {
                                    strokeColor: Color.blue,
                                    strokeOpacity: 1,
                                    strokeWeight: 5
                                },
                                highlight: {
                                    strokeColor: Color.blue,
                                    strokeOpacity: 1,
                                    strokeWeight: 5
                                },
                                fade: {
                                    strokeColor: Color.grey5,
                                    strokeOpacity: 0.2,
                                    strokeWeight: 2
                                }
                            };
                        }
                        ;
                    case "leaflet": {
                        return {
                            default: {
                                weight: 3,
                                color: Color.stopDark,
                                opacity: 1
                            },
                            highlight: {
                                weight: 4,
                                color: Color.stopDark,
                                opacity: 1
                            },
                            fade: {
                                weight: 4,
                                color: Color.grey4,
                                opacity: 0.5
                            }
                        };
                    }
                }
            },
        };
    }
    StopsPolyline.prototype.getEncodedPath = function (data) {
        return data.route;
    };
    return StopsPolyline;
}());
export { StopsPolyline };
export var StopsPolylineTrace = TraceMixin(PolylinesMixin(StyleMixin(MapItemsMixin(StopsPolyline))));
//# sourceMappingURL=stops-polyline.js.map