import * as _ from "underscore";
import { TimelineSegment } from "./timeline-segment";
var ReplayTrace = (function () {
    function ReplayTrace() {
        this.timelineSegment = new TimelineSegment();
    }
    ReplayTrace.prototype.getSegmentTypes = function (userSegments) {
        return _.reduce(userSegments, function (segmentType, segment) {
            if (segment.type == 'stop') {
                if (segment.place && segment.place.location)
                    segmentType.stopSegment.push(segment);
            }
            else {
                if (segment.route)
                    segmentType.tripSegment.push(segment);
            }
            return segmentType;
        }, { tripSegment: [], stopSegment: [] });
    };
    //segments replay
    ReplayTrace.prototype.clearTimeline = function () {
        this.timelineSegment.clearTimeline();
    };
    Object.defineProperty(ReplayTrace.prototype, "stats", {
        get: function () {
            return this.timelineSegment.stats;
        },
        enumerable: true,
        configurable: true
    });
    // get segments() {
    //   return this.timelineSegment.placeline
    // }
    ReplayTrace.prototype.updateTimeline = function (user) {
        this.timelineSegment.update(user);
    };
    ReplayTrace.prototype.setSegmentPlayCallback = function (cb) {
        this.timelineSegment.playSegmentCallback = cb;
    };
    return ReplayTrace;
}());
export { ReplayTrace };
;
//# sourceMappingURL=replay-trace.js.map