"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var trace_1 = require("../mixins/trace");
var polyline_renderer_1 = require("../mixins/polyline-renderer");
var map_items_1 = require("../mixins/map-items");
var styles_1 = require("../mixins/styles");
var ht_utility_1 = require("ht-utility");
var StopsPolyline = /** @class */ (function () {
    function StopsPolyline(mapInstance) {
        this.mapInstance = mapInstance;
        this.name = "stop polyline";
        this.styleFunct = {
            get: function (type) {
                switch (type) {
                    case "google":
                        {
                            return {
                                default: {
                                    strokeColor: ht_utility_1.Color.blue,
                                    strokeOpacity: 1,
                                    strokeWeight: 5
                                },
                                highlight: {
                                    strokeColor: ht_utility_1.Color.blue,
                                    strokeOpacity: 1,
                                    strokeWeight: 5
                                },
                                fade: {
                                    strokeColor: ht_utility_1.Color.grey5,
                                    strokeOpacity: 0.2,
                                    strokeWeight: 2
                                }
                            };
                        }
                        ;
                    case "leaflet": {
                        return {
                            default: {
                                weight: 3,
                                color: ht_utility_1.Color.stopDark,
                                opacity: 1
                            },
                            highlight: {
                                weight: 4,
                                color: ht_utility_1.Color.stopDark,
                                opacity: 1
                            },
                            fade: {
                                weight: 4,
                                color: ht_utility_1.Color.grey4,
                                opacity: 0.5
                            }
                        };
                    }
                }
            },
        };
    }
    StopsPolyline.prototype.getEncodedPath = function (data) {
        return data.route;
    };
    return StopsPolyline;
}());
exports.StopsPolyline = StopsPolyline;
exports.StopsPolylineTrace = trace_1.TraceMixin(polyline_renderer_1.PolylinesMixin(styles_1.StyleMixin(map_items_1.MapItemsMixin(StopsPolyline))));
//# sourceMappingURL=stops-polyline.js.map