"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ht_google_maps_wrapper_1 = require("ht-google-maps-wrapper");
var ht_leaflet_wrapper_1 = require("ht-leaflet-wrapper");
exports.mapTypeService = (function () {
    var instance;
    var currentmapType;
    function getMapType(mapType) {
        switch (mapType) {
            case 'leaflet': {
                return new ht_leaflet_wrapper_1.LeafletMapUtilsClass();
            }
            case 'google': {
                return new ht_google_maps_wrapper_1.GoogleMapUtilsClass();
            }
            default: {
                return new ht_google_maps_wrapper_1.GoogleMapUtilsClass();
            }
        }
    }
    return {
        getInstance: function (mapType) {
            if (!instance || !currentmapType) {
                currentmapType = mapType;
                instance = getMapType(mapType);
            }
            return instance;
        }
    };
})();
//# sourceMappingURL=map-type.js.map