"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DataEntities = (function () {
    function DataEntities() {
        this.entities = {};
        this.newData = [];
    }
    DataEntities.prototype.get = function (id) {
        return this.entities[id] || null;
    };
    DataEntities.prototype.set = function (id, datum, markNew) {
        if (markNew === void 0) { markNew = false; }
        this.entities[id] = datum;
        if (markNew)
            this.newData.push(id);
    };
    DataEntities.prototype.keys = function () {
        return Object.keys(this.entities);
    };
    DataEntities.prototype.values = function () {
        var _this = this;
        return this.keys().map(function (key) { return _this.entities[key]; });
    };
    ;
    DataEntities.prototype.getOldIds = function () {
        var _this = this;
        var oldIds = this.keys().filter(function (id) { return !_this.newData.includes(id); });
        this.newData = [];
        return oldIds;
    };
    DataEntities.prototype.clear = function () {
        this.entities = {};
        this.newData = [];
    };
    DataEntities.prototype.delete = function (id, cb) {
        if (cb)
            cb(this.entities[id]);
        delete this.entities[id];
    };
    return DataEntities;
}());
exports.DataEntities = DataEntities;
//# sourceMappingURL=data-Entities.js.map