"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
// import { GlobalMap } from "../global/map-service";
var operators_1 = require("rxjs/operators");
function DataObservableMixin(Base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _super.apply(this, args) || this;
        }
        class_1.prototype._trace = function (data, map) {
            if (data === void 0) { data = []; }
            if (!this.traceData$) {
                this.traceData$ = new rxjs_1.BehaviorSubject(data);
            }
            else {
                this.traceData$.next(data);
            }
            this.setData$(this.traceData$);
        };
        class_1.prototype._procData$ = function () {
            var _this = this;
            return function (source$) {
                return source$.pipe(
                // filter(data => !!data),
                operators_1.map(function (pageData) {
                    if (pageData) {
                        var isNew = pageData && pageData.count && !pageData.previous;
                        var results = pageData ? pageData.results : [];
                        return _this.getMarkersArray(results, isNew);
                    }
                    else {
                        return _this.emptyRenderData();
                    }
                }));
            };
        };
        class_1.prototype.getMarkersArray = function (markersArray, isNew) {
            var _this = this;
            if (markersArray === void 0) { markersArray = []; }
            if (isNew === void 0) { isNew = false; }
            return markersArray.reduce(function (acc, item) {
                var isValid = _this.isValidMapItems
                    ? _this.isValidMapItems(item)
                    : !!_this.getPosition(item);
                if (isValid) {
                    acc.valid.push(item);
                }
                else {
                    acc.invalid.push(item);
                }
                return acc;
            }, { valid: [], invalid: [], isNew: isNew });
        };
        class_1.prototype.setPageData$ = function (data$, config) {
            if (config === void 0) { config = {}; }
            if (this.dataSub) {
                this.dataSub.unsubscribe();
            }
            var hide$ = config.hide$;
            this.dataPageSource$ = hide$
                ? rxjs_1.combineLatest(data$, hide$.pipe(operators_1.distinctUntilChanged()), function (data, hide) {
                    return !!hide ? { results: [], count: 0, next: "", previous: "" } : data;
                })
                : data$;
            this.data$ = this.dataPageSource$.pipe(this._procData$());
            this._initDataObserver();
        };
        class_1.prototype.setData$ = function (data$, config) {
            var _this = this;
            if (config === void 0) { config = {}; }
            if (this.dataSub) {
                this.dataSub.unsubscribe();
            }
            ;
            var hide$ = config.hide$;
            this.dataArraySource$ = hide$
                ? rxjs_1.combineLatest(data$, hide$.pipe(operators_1.distinctUntilChanged()), function (data, hide) { return (!!hide ? [] : data); })
                : data$;
            this.data$ = this.dataArraySource$.pipe(operators_1.scan(function (acc, data) {
                return { new: data, old: acc.new };
            }, { old: null, new: null }), operators_1.map(function (dataArray) {
                return _this.getMarkersArray(dataArray.new || [], !dataArray.old);
            }));
            this._initDataObserver();
        };
        // _initData$() {
        //   let userData$ = this.dataPageSource$.pipe(
        //     filter(data => !!GlobalMap.map),
        //     pluck('valid'),
        //     scan((acc: {user: any, oldUser: any}, data: object) => {
        //       const oldUser = acc.user;
        //       return {user: data, oldUser }
        //     }, {user: null, oldUser: null})
        //   );
        //   return userData$;
        // };
        class_1.prototype._initDataObserver = function () {
            var _this = this;
            var mapData$ = this.data$;
            var render$ = rxjs_1.combineLatest(mapData$, this.mapInstance.map$).pipe(operators_1.map(function (_a) {
                var mapData = _a[0], map = _a[1];
                return map ? mapData : _this.emptyRenderData();
            }));
            // function isNewId (newItem, old) {
            //   if(!old && newItem) return true;
            //   if(newItem && old) return  newItem.id !== old.id
            // }
            // function isNewList(newList, old) {
            //   if(!old && newList) return true;
            //   if(newList && old) return !newList.next && newList.count
            // }
            var sub = render$.subscribe(function (_a) {
                var valid = _a.valid, invalid = _a.invalid, isNew = _a.isNew;
                _this.trace(valid);
                if (isNew)
                    _this.mapInstance.resetBounds();
            });
            this.dataSub = sub;
        };
        class_1.prototype.emptyRenderData = function () {
            return { valid: [], invalid: [], isNew: false };
        };
        class_1.prototype.clear = function () {
            this.dataSub.unsubscribe();
        };
        return class_1;
    }(Base));
}
exports.DataObservableMixin = DataObservableMixin;
//# sourceMappingURL=data-observable.js.map