import { Entity, StyleFunct } from "../interfaces";
import { MapInstance } from "../map-utils/map-instance";
import { IMarkersArray, SetDataConfig } from "../mixins/data-observable";
import { HtPosition, IPathBearingTime, IActionWithPolyline } from "ht-models";
import { Subscription, Observable, BehaviorSubject } from "rxjs";
import { AnimationsEntities } from "../mixins/animations-entities";
import { HtCustomEvent, IEventSub } from "ht-utility";
export declare class ActionsDataPolyline {
    name: string;
    mapInstance: any;
    styleFunct: StyleFunct;
    setTimeAwareAnimationEntity: (animationEntity?: AnimationsEntities) => void;
    setData$: (data$: Observable<any[]>) => void;
    constructor(mapInstance: MapInstance);
    isValidMapItems(data: any): boolean;
    getTimeAwarePath(data: any): any;
    getEncodedPositionTime(data: IActionWithPolyline): string;
    getEncodedPath(data: IActionWithPolyline): string;
    getPosition(action: IActionWithPolyline): HtPosition | null;
    getTimeAwarePolyline(data: IActionWithPolyline): string;
}
export declare const ActionsPolylineTrace: {
    new (...args: any[]): {
        dataSub: Subscription;
        dataPageSource$: Observable<{
            count: number;
            next: string;
            previous: string;
            results: any[];
        }>;
        dataArraySource$: Observable<any[]>;
        data$: Observable<IMarkersArray>;
        traceData$: BehaviorSubject<any[]>;
        _trace(data?: any[], map?: any): void;
        _procData$(): (source$: Observable<{
            count: number;
            next: string;
            previous: string;
            results: any[];
        }>) => Observable<any>;
        getMarkersArray(markersArray?: any[], isNew?: boolean): any;
        setPageData$(data$: Observable<{
            count: number;
            next: string;
            previous: string;
            results: any[];
        }>, config?: SetDataConfig): void;
        setData$(data$: Observable<any[]>, config?: SetDataConfig): void;
        _initDataObserver(): void;
        emptyRenderData(): IMarkersArray;
        clear(): void;
        trace: (data: any, map?: any) => any;
        isValidMapItems?: (data: any) => boolean;
        getPosition: (data: any) => HtPosition;
        mapInstance: MapInstance;
    };
} & {
    new (...args: any[]): {
        isAnimated: boolean;
        animationEntities: AnimationsEntities;
        toNotTraceItem: boolean;
        subs: {
            [id: string]: any;
        };
        setTimeAwareAnimationEntity(animationEntity?: AnimationsEntities): void;
        clearItem(entity: any): void;
        update(entity: any, pathBearing: any): void;
        initSub(id: any, animId?: string): void;
        clearSub(id: any): void;
        getEntity(id?: any): Entity<any>;
        getTimeAwarePolyline?(data: any): string;
        getTimeAwarePath?(data: any): (string | number)[][];
        trackBy(datum: any): string;
        trackAnimationBy(datum: any): string;
    };
} & {
    new (...args: any[]): {
        trace(data: any[], map?: any): boolean;
        traceItem(datum: any): void;
        addEvents(item: any, id: any): void;
        bustOldItem(): void;
        name?: string;
        getItem: (data: any) => any;
        onMouseLeave?: (trace: any) => void;
        onClick?: (trace: any) => void;
        onMouseEnter?: (trace: any) => void;
        setStyle: (entity: Entity<any>) => void;
        update: (entity: any, pathBearing?: IPathBearingTime) => void;
        traceEffect?: () => void;
        removeAll: (entities: any) => void;
        clearItem: (entity: Entity<any>) => void;
        toNotTraceItem?: boolean;
        trackBy(datum: any): string;
        entities: {
            [id: string]: Entity<any>;
        };
        mapInstance: MapInstance;
        event: HtCustomEvent;
    };
} & {
    new (...args: any[]): {
        entities: {
            [id: string]: Entity<any>;
        };
        toIncludeInBounds: boolean;
        extendBounds(bounds: any): any;
        getBounds: (item: any, bounds: any) => any;
        mapInstance: MapInstance;
    };
} & {
    new (...args: any[]): {
        positionTimeArray: any[];
        getItem(data: any): any;
        getBounds(item: any, bounds?: any): any;
        update({item, data}: {
            item: any;
            data: any;
        }, pathBearing: IPathBearingTime): void;
        setItemStyle(item: any, style: any): void;
        getPath?(path: (string | number)[][]): HtPosition[];
        getEncodedPositionTime?: any;
        getEncodedPath?(data: any): any;
        getStyle: (string?: any) => object;
        mapInstance: MapInstance;
        toNotSetMap?: boolean;
    };
} & {
    new (...args: any[]): {
        entities: {
            [id: string]: Entity<any>;
        };
        getItem(data: any): any;
        getBounds(item: any, bounds?: any): any;
        update({item, data}: {
            item: any;
            data: any;
        }, positionBearing?: IPathBearingTime): void;
        getStyle: (styleType?: any) => object;
        getPosition: (data: any) => HtPosition;
        forceExtendBounds?: boolean;
        mapInstance: MapInstance;
        toNotSetMap?: boolean;
        trackBy(datum: any): string;
        event: HtCustomEvent;
    };
} & {
    new (...args: any[]): {
        defaultstyleFunct: StyleFunct;
        styleType: string;
        highlightedId: string;
        styleObj: object;
        getStyle(selectedStyleType?: string, data?: any, fallbackStyle?: any): any;
        setStyleType(styleType?: string): void;
        setStyle({item, data}: {
            item: any;
            data: any;
        }): void;
        getStyleType(datum: any): string;
        setItemStyle(item: any, style: any): void;
        styleFunct: StyleFunct;
        name?: string;
        mapInstance: MapInstance;
        trackBy(datum: any): string;
        isAnimated?: boolean;
    };
} & {
    new (...args: any[]): {
        entities: {
            [id: string]: Entity<any>;
        };
        event: HtCustomEvent;
        htShow(item: any): string;
        getEntity(id?: string): Entity<any>;
        trackBy(datum: any): any;
        trackAnimationBy(datum: any): any;
        onEntityUpdate(id: any): {
            subscribe: (cb: any) => IEventSub;
        };
        removeItem(item: any): void;
        removeAll(entities: any): void;
        clear(): void;
        clearItem({item, data}: {
            item: any;
            data: any;
        }): void;
        removeData(data: any): void;
        mapInstance: MapInstance;
    };
} & typeof ActionsDataPolyline;
