import { HtPosition } from "ht-models";
import { Entity, StyleFunct } from "../interfaces";
import { MapInstance } from "../map-utils/map-instance";
import { TimeAwareAnimation } from "time-aware-polyline";
import { IPathBearingTime } from "ht-models";
import { HtCustomEvent, IEventSub } from "ht-utility";
export declare class CurrentUser {
    mapInstance: MapInstance;
    name: string;
    animation?: TimeAwareAnimation;
    styleFunct: StyleFunct;
    constructor(mapInstance: MapInstance);
    getPosition(data: any): HtPosition;
    getDivContent(data: any): string;
    isValidMapItems(data: any): boolean;
}
export declare const CurrentUserTrace: {
    new (...args: any[]): {
        isAnimated: boolean;
        setTimeAwareAnimation(animation: TimeAwareAnimation): void;
        animation?: TimeAwareAnimation;
        getEntity(): Entity<any>;
        update(entity: any, pathBearing: IPathBearingTime): void;
    };
} & {
    new (...args: any[]): {
        trace(user: any, map?: any): void;
        entities: {
            [id: string]: Entity<any>;
        };
    };
} & {
    new (...args: any[]): {
        getItem(data: any): any;
        update({item, data}: {
            item: any;
            data: any;
        }, pathBearing?: IPathBearingTime): void;
        setContent({item, content}: {
            item: any;
            content: any;
        }): void;
        setStyle(entity: any): void;
        getDivContent: (data: any, bearing?: number) => string;
        getStyle: (type?: any) => object;
        mapInstance: MapInstance;
    };
} & {
    new (...args: any[]): {
        trace(data: any[], map?: any): boolean;
        traceItem(datum: any): void;
        addEvents(item: any, id: any): void;
        bustOldItem(): void;
        name?: string;
        getItem: (data: any) => any;
        onMouseLeave?: (trace: any) => void;
        onClick?: (trace: any) => void;
        onMouseEnter?: (trace: any) => void;
        setStyle: (entity: Entity<any>) => void;
        update: (entity: any, pathBearing?: IPathBearingTime) => void;
        traceEffect?: () => void;
        removeAll: (entities: any) => void;
        clearItem: (entity: Entity<any>) => void;
        toNotTraceItem?: boolean;
        trackBy(datum: any): string;
        entities: {
            [id: string]: Entity<any>;
        };
        mapInstance: MapInstance;
        event: HtCustomEvent;
    };
} & {
    new (...args: any[]): {
        entities: {
            [id: string]: Entity<any>;
        };
        getItem(data: any): any;
        getBounds(item: any, bounds?: any): any;
        update({item, data}: {
            item: any;
            data: any;
        }, positionBearing?: IPathBearingTime): void;
        getStyle: (styleType?: any) => object;
        getPosition: (data: any) => HtPosition;
        forceExtendBounds?: boolean;
        mapInstance: MapInstance;
        toNotSetMap?: boolean;
        trackBy(datum: any): string;
        event: HtCustomEvent;
    };
} & {
    new (...args: any[]): {
        defaultstyleFunct: StyleFunct;
        styleType: string;
        highlightedId: string;
        styleObj: object;
        getStyle(selectedStyleType?: string, data?: any, fallbackStyle?: any): any;
        setStyleType(styleType?: string): void;
        setStyle({item, data}: {
            item: any;
            data: any;
        }): void;
        getStyleType(datum: any): string;
        setItemStyle(item: any, style: any): void;
        styleFunct: StyleFunct;
        name?: string;
        mapInstance: MapInstance;
        trackBy(datum: any): string;
        isAnimated?: boolean;
    };
} & {
    new (...args: any[]): {
        entities: {
            [id: string]: Entity<any>;
        };
        event: HtCustomEvent;
        htShow(item: any): string;
        getEntity(id?: string): Entity<any>;
        trackBy(datum: any): any;
        trackAnimationBy(datum: any): any;
        onEntityUpdate(id: any): {
            subscribe: (cb: any) => IEventSub;
        };
        removeItem(item: any): void;
        removeAll(entities: any): void;
        clear(): void;
        clearItem({item, data}: {
            item: any;
            data: any;
        }): void;
        removeData(data: any): void;
        mapInstance: MapInstance;
    };
} & typeof CurrentUser;
