import { HtPosition, IPathBearingTime } from "ht-models";
import { CurrentUser } from "./current-user";
import { IReplayHead, Entity, StyleFunct } from "../interfaces";
import { HtCustomEvent, IEventSub } from "ht-utility";
import { MapInstance } from "../map-utils/map-instance";
export declare class ReplayMarker extends CurrentUser {
    setPopup: (id?: string) => void;
    trace: (data) => void;
    clear: () => void;
    name: string;
    styleObj: {
        default: {
            radius: number;
            fillColor: string;
            fillOpacity: number;
            weight: number;
            color: string;
            pane: string;
        };
        popup: {
            offset: number[];
            closeButton: boolean;
        };
        highlight: {
            radius: number;
            fillColor: string;
            fillOpacity: number;
            weight: number;
            color: string;
            pane: string;
        };
        fade: {
            radius: number;
            fillColor: string;
            fillOpacity: number;
            weight: number;
            color: string;
            pane: string;
        };
    };
    getPosition(data: IReplayHead): HtPosition;
    getBearing(data: IReplayHead): number;
    getInfoContent(data: IReplayHead): string;
}
export declare const ReplayMarkerTrace: {
    new (...args: any[]): {
        trace(user: any, map?: any): void;
        entities: {
            [id: string]: Entity<any>;
        };
    };
} & {
    new (...args: any[]): {
        getItem(data: any): any;
        mapInstance: MapInstance;
    };
} & {
    new (...arg: any[]): {
        popup: any;
        defaultPopupStyle: {
            disableAutoPan: boolean;
        };
        addPopup(): void;
        setPopup(id: string): void;
        onMouseEnter(entity: Entity<any>): void;
        onMouseLeave(entity: Entity<any>): void;
        getStyle: (styleType?: any, fallbackStyle?: any) => object;
        entities: {
            [id: string]: Entity<any>;
        };
        getPosition: (data: any) => HtPosition;
        getInfoContent: (data: any) => string;
        mapInstance: MapInstance;
        trackBy(datum: any): string;
    };
} & {
    new (...args: any[]): {
        trace(data: any[], map?: any): boolean;
        traceItem(datum: any): void;
        addEvents(item: any, id: any): void;
        bustOldItem(): void;
        name?: string;
        getItem: (data: any) => any;
        onMouseLeave?: (trace: any) => void;
        onClick?: (trace: any) => void;
        onMouseEnter?: (trace: any) => void;
        setStyle: (entity: Entity<any>) => void;
        update: (entity: any, pathBearing?: IPathBearingTime) => void;
        traceEffect?: () => void;
        removeAll: (entities: any) => void;
        clearItem: (entity: Entity<any>) => void;
        toNotTraceItem?: boolean;
        trackBy(datum: any): string;
        entities: {
            [id: string]: Entity<any>;
        };
        mapInstance: MapInstance;
        event: HtCustomEvent;
    };
} & {
    new (...args: any[]): {
        entities: {
            [id: string]: Entity<any>;
        };
        getItem(data: any): any;
        getBounds(item: any, bounds?: any): any;
        update({item, data}: {
            item: any;
            data: any;
        }, positionBearing?: IPathBearingTime): void;
        getStyle: (styleType?: any) => object;
        getPosition: (data: any) => HtPosition;
        forceExtendBounds?: boolean;
        mapInstance: MapInstance;
        toNotSetMap?: boolean;
        trackBy(datum: any): string;
        event: HtCustomEvent;
    };
} & {
    new (...args: any[]): {
        defaultstyleFunct: StyleFunct;
        styleType: string;
        highlightedId: string;
        styleObj: object;
        getStyle(selectedStyleType?: string, data?: any, fallbackStyle?: any): any;
        setStyleType(styleType?: string): void;
        setStyle({item, data}: {
            item: any;
            data: any;
        }): void;
        getStyleType(datum: any): string;
        setItemStyle(item: any, style: any): void;
        styleFunct: StyleFunct;
        name?: string;
        mapInstance: MapInstance;
        trackBy(datum: any): string;
        isAnimated?: boolean;
    };
} & {
    new (...args: any[]): {
        entities: {
            [id: string]: Entity<any>;
        };
        event: HtCustomEvent;
        htShow(item: any): string;
        getEntity(id?: string): Entity<any>;
        trackBy(datum: any): any;
        trackAnimationBy(datum: any): any;
        onEntityUpdate(id: any): {
            subscribe: (cb: any) => IEventSub;
        };
        removeItem(item: any): void;
        removeAll(entities: any): void;
        clear(): void;
        clearItem({item, data}: {
            item: any;
            data: any;
        }): void;
        removeData(data: any): void;
        mapInstance: MapInstance;
    };
} & typeof ReplayMarker;
