import { IPlaceline, IUserPlaceline, IPlacelineMod } from "ht-models";
import { Observable } from "rxjs/Observable";
import { Subscription } from "rxjs/Subscription";
import { CompoundSetDataConfig } from "../mixins/compounds-data-observable";
import { MapInstance } from "../map-utils/map-instance";
import { HtMap } from "ht-map-wrapper";
import { TimeAwareAnimation } from "time-aware-polyline";
import { StopsPolyline } from "../entities/stops-polyline";
export declare class Placeline {
    options: HtSegmentsTraceOptions;
    segmentsPolylines: any;
    stopMarkers: any;
    actionMarkers: any;
    userMarker: any;
    animPolyline: any;
    allowedEvents: {};
    mapInstance: MapInstance;
    actionsPolyline: any;
    anim: TimeAwareAnimation;
    stopsPolyline: StopsPolyline;
    constructor(options: HtSegmentsTraceOptions);
    readonly map: HtMap;
    trace(user: IPlacelineMod, map?: any): void;
    traceStopsPolyline(user: IPlacelineMod, selectedSegment: any): void;
    traceAnimPolyline(restTrip: any, selectedSegment: any): void;
    traceStops(stops: IPlaceline[], selectedSegment: any, lastSegment: any): void;
    traceSegments(trips: IPlaceline[], selectedSegment: any): void;
    traceAction(user: IUserPlaceline, selectedSegment: any): void;
    setHighlightId(user: IPlacelineMod): void;
    getTimeAwarePolyline(segment: IPlaceline): string;
    extendBounds(bounds: any): any;
    protected getSegmentTypes(userSegments: IPlaceline[]): ISegmentType;
}
export declare const PlacelineTrace: {
    new (...args: any[]): {
        dataSub: Subscription;
        dataSource$: Observable<object>;
        data$: Observable<object>;
        compoundSetDataConfig: CompoundSetDataConfig;
        _procData$(): (source$: Observable<any>) => Observable<{
            valid: any[];
            invalid: any[];
        }>;
        setCompoundData$(data$: Observable<object>, config?: CompoundSetDataConfig): void;
        _initData$(): Observable<object>;
        _initDataObserver(): void;
        trace: (data: any, map?: any) => any;
        isValidMapItems?: (data: any) => boolean;
        mapInstance: MapInstance;
        toResetMap?: (newData: any, oldData: any) => boolean;
    };
} & typeof Placeline;
export interface ISegmentType {
    tripSegment: IPlaceline[];
    stopSegment: IPlaceline[];
    lastSegment?: IPlaceline;
    lastIsTrip?: boolean;
}
export interface HtSegmentsTraceOptions {
    mapInstance: MapInstance;
}
