import { HtBounds, HtMap, HtMapType } from "ht-map-wrapper";
import { IUserPlaceline } from "ht-models";
import { ReplaySubject } from "rxjs/ReplaySubject";
import { Subscription } from "rxjs/Subscription";
import { MapInstance } from "../map-utils/map-instance";
export declare class HtMapClass {
    mapType: HtMapType;
    mapInstance: MapInstance;
    userDataSub: Subscription;
    placeline: any;
    usersCluster: any;
    usersHeatmap: any;
    actionsHeatmap: any;
    actionsCluster: any;
    leafletSetBoundsOptions: L.PanOptions;
    googleSetBoundsOptions: {};
    googleMapOptions: {
        center: {
            lat: number;
            lng: number;
        };
        zoom: number;
        fullscreenControl: boolean;
        streetViewControl: boolean;
        styles: ({
            "featureType": string;
            "elementType": string;
            "stylers": ({
                "saturation": number;
                color?: undefined;
                lightness?: undefined;
            } | {
                "color": string;
                saturation?: undefined;
                lightness?: undefined;
            } | {
                "lightness": number;
                saturation?: undefined;
                color?: undefined;
            })[];
        } | {
            "featureType": string;
            "elementType": string;
            "stylers": ({
                "visibility": string;
                color?: undefined;
                lightness?: undefined;
            } | {
                "color": string;
                visibility?: undefined;
                lightness?: undefined;
            } | {
                "lightness": number;
                visibility?: undefined;
                color?: undefined;
            })[];
        } | {
            "featureType": string;
            "elementType": string;
            "stylers": ({
                "color": string;
                lightness?: undefined;
                weight?: undefined;
            } | {
                "lightness": number;
                color?: undefined;
                weight?: undefined;
            } | {
                "weight": number;
                color?: undefined;
                lightness?: undefined;
            })[];
        } | {
            "featureType": string;
            "elementType": string;
            "stylers": ({
                "saturation": string;
                gamma?: undefined;
                lightness?: undefined;
                color?: undefined;
            } | {
                "gamma": string;
                saturation?: undefined;
                lightness?: undefined;
                color?: undefined;
            } | {
                "lightness": string;
                saturation?: undefined;
                gamma?: undefined;
                color?: undefined;
            } | {
                "color": string;
                saturation?: undefined;
                gamma?: undefined;
                lightness?: undefined;
            })[];
        })[];
    };
    leafletMapOptions: {
        center: number[];
        zoom: number;
    };
    mapItemsSet: any[];
    constructor(mapType?: HtMapType, options?: HtMapClassOptions);
    readonly segmentTrace: any;
    readonly map$: ReplaySubject<HtMap>;
    readonly map: HtMap;
    initMap(elem: HTMLElement, options?: {}): HtMap;
    tracePlaceline(user: IUserPlaceline): void;
    resetBounds(options?: any): void;
    getBoundsItem(items: any): any;
    getBounds(bounds: any, item: any): any;
    setBounds(bounds: HtBounds, options?: any): void;
    inValidateSize(): void;
    addEntities(entities: any): void;
    clear(): void;
}
export interface HtMapClassOptions {
    mapKey?: string;
}
