import { Constructor, Entity } from "../interfaces";
import { TimeAwareAnimation } from "time-aware-polyline";
import { IPathBearingTime } from "ht-models";
export interface IAnimationBase {
    animation?: TimeAwareAnimation;
    getEntity(): Entity<any>;
    update(entity: any, pathBearing: IPathBearingTime): void;
}
export declare function AnimationMixin<TBase extends Constructor<IAnimationBase>>(Base: TBase): {
    new (...args: any[]): {
        isAnimated: boolean;
        setTimeAwareAnimation(animation: TimeAwareAnimation): void;
        animation?: TimeAwareAnimation;
        getEntity(): Entity<any>;
        update(entity: any, pathBearing: IPathBearingTime): void;
    };
} & TBase;
