import { Constructor } from "../interfaces";
import { MapInstance } from "../map-utils/map-instance";
import { IPathBearingTime } from "ht-models";
export interface IDivMarkersBase {
    getDivContent: (data, bearing?: number) => string;
    getStyle: (type?) => object;
    update(entity: any, pathBearing?: any): void;
    mapInstance: MapInstance;
}
export declare function DivMarkersMixin<TBase extends Constructor<IDivMarkersBase>>(Base: TBase): {
    new (...args: any[]): {
        getItem(data: any): any;
        update({item, data}: {
            item: any;
            data: any;
        }, pathBearing?: IPathBearingTime): void;
        setContent({item, content}: {
            item: any;
            content: any;
        }): void;
        setStyle(entity: any): void;
        getDivContent: (data: any, bearing?: number) => string;
        getStyle: (type?: any) => object;
        mapInstance: MapInstance;
    };
} & TBase;
