import { HtPosition } from "ht-models";
import { Constructor, Entities, Entity } from "../interfaces";
import { MapInstance } from "../map-utils/map-instance";
export interface PopupBase {
    getStyle: (styleType?, fallbackStyle?) => object;
    entities: Entities<any>;
    getPosition: (data) => HtPosition;
    getInfoContent: (data) => string;
    mapInstance: MapInstance;
    trackBy(datum: any): string;
}
export declare function PopupMixin<TBase extends Constructor<PopupBase>>(Base: TBase): {
    new (...arg: any[]): {
        popup: any;
        defaultPopupStyle: {
            disableAutoPan: boolean;
        };
        addPopup(): void;
        setPopup(id: string): void;
        onMouseEnter(entity: Entity<any>): void;
        onMouseLeave(entity: Entity<any>): void;
        getStyle: (styleType?: any, fallbackStyle?: any) => object;
        entities: Entities<any>;
        getPosition: (data: any) => HtPosition;
        getInfoContent: (data: any) => string;
        mapInstance: MapInstance;
        trackBy(datum: any): string;
    };
} & TBase;
