import { IReplayHead, IReplayPlayer, IReplayStats } from "../interfaces";
import { BehaviorSubject } from "rxjs/BehaviorSubject";
import { ITimeAwarePoint, HtPosition } from "ht-models";
import { TimeAwareEncoder } from "time-aware-polyline";
import { Observable } from "rxjs/Observable";
export declare class TimelineReplay extends TimeAwareEncoder {
    timeAwareArray: ITimeAwarePoint[];
    map: any;
    stats: any;
    stats$: BehaviorSubject<any>;
    head: any;
    head$: BehaviorSubject<any>;
    playerSub: any;
    player$: BehaviorSubject<IReplayPlayer>;
    player: IReplayPlayer;
    debug: boolean;
    frameInterval: number;
    skipStops: boolean;
    constructor();
    addListerner(): void;
    getPositionBearingnAtTime(time: string): {
        position: HtPosition;
        bearing: number;
    };
    setStats(stats: IReplayStats | null): void;
    setReplayHead(head: IReplayHead | null): void;
    getReplayStats(): Observable<any>;
    getReplayHead(): Observable<any>;
    currentTimeEffects(time: any): void;
    currentSegmentEffects(segment: any): void;
    getLastPositionBearing(): {
        position: HtPosition;
        bearing: number;
    };
    getLocationsAtTimesT(times: string[]): any[];
    private getNoTrackingSegments(events);
    goToTimePercent(timePercent: number, toPause?: boolean): void;
    jumpToTimePercent(timePercent: number): void;
    private getNextTimePercent(head);
    private getIncTimePercent(head);
    private getTimeFromTimePercent(timePercent);
    jumpToTime(time: string, timePercent: any): void;
    goToTime(time: string, timePercent: any): void;
    clear(): void;
    play(): void;
    toggleSkipStops(): void;
    pause(): void;
    stop(): void;
    setSpeed(speed: number): void;
    setPlayer(obj: Partial<IReplayPlayer>): void;
}
