import { Constructor } from "../interfaces";
import { HtPosition } from "ht-models";
import { MapInstance } from "../map-utils/map-instance";
export interface IHeatmapBase {
    getStyle: (styleType?) => object;
    getPosition: (data) => HtPosition;
    mapInstance: MapInstance;
}
export declare function HeatmapMixin<TBase extends Constructor<IHeatmapBase>>(Base: TBase): {
    new (...args: any[]): {
        map: any;
        heatmap: any;
        forceExtendBounds: boolean;
        entities: any[];
        trace(items: any[], map?: any): boolean;
        getBounds(item: any, bounds?: any): any;
        clear(): void;
        getStyle: (styleType?: any) => object;
        getPosition: (data: any) => HtPosition;
        mapInstance: MapInstance;
    };
} & TBase;
