import { Constructor, Entities, Entity } from "../interfaces";
import { MapInstance } from "../map-utils/map-instance";
import { HtCustomEvent, IEventSub } from "ht-utility";
export interface IMapItemsBase {
    mapInstance: MapInstance;
    trackBy?(datum: any): string;
    trackAnimationBy?(datum: any): string;
}
export declare function MapItemsMixin<TBase extends Constructor<IMapItemsBase>>(Base: TBase): {
    new (...args: any[]): {
        entities: Entities<any>;
        event: HtCustomEvent;
        htShow(item: any): string;
        getEntity(id?: string): Entity<any>;
        trackBy(datum: any): any;
        trackAnimationBy(datum: any): any;
        onEntityUpdate(id: any): {
            subscribe: (cb: any) => IEventSub;
        };
        removeItem(item: any): void;
        removeAll(entities: any): void;
        clear(): void;
        clearItem({item, data}: {
            item: any;
            data: any;
        }): void;
        removeData(data: any): void;
        mapInstance: MapInstance;
    };
} & TBase;
