import { Constructor, StyleFunct } from "../interfaces";
import { MapInstance } from "../map-utils/map-instance";
export interface IStyleBase {
    styleFunct: StyleFunct;
    name?: string;
    mapInstance: MapInstance;
    trackBy(datum: any): string;
    isAnimated?: boolean;
}
export declare function StyleMixin<TBase extends Constructor<IStyleBase>>(Base: TBase): {
    new (...args: any[]): {
        defaultstyleFunct: StyleFunct;
        styleType: string;
        highlightedId: string;
        styleObj: object;
        getStyle(selectedStyleType?: string, data?: any, fallbackStyle?: any): any;
        setStyleType(styleType?: string): void;
        setStyle({item, data}: {
            item: any;
            data: any;
        }): void;
        getStyleType(datum: any): string;
        setItemStyle(item: any, style: any): void;
        styleFunct: StyleFunct;
        name?: string;
        mapInstance: MapInstance;
        trackBy(datum: any): string;
        isAnimated?: boolean;
    };
} & TBase;
