import { PolylineUtils } from "./polyline";
import { ITimeAwarePoint } from "ht-models";
export declare class TimeAwareAnimation {
    polylineUtils: PolylineUtils;
    currentTime: string;
    animationPoll: any;
    animationSpeed: number;
    animationProps: {
        speedScale: number;
        interval: number;
    };
    updateEvent: CustomEvent;
    constructor();
    updatePolylineString(timeAwarePolylineString: string): void;
    update(timeAwarePolyline: ITimeAwarePoint[]): boolean;
    private handleAnimation(timeAwarePolyline);
    private updateCurrentTime();
    private setPathBearing();
    updatePathBearing(path: any, bearing: any): void;
    private capTime(callback?);
    clearAnimationPoll(): void;
    private getTimeToAdd();
    private currentTimePolylineData();
    clear(): void;
    private addISOTime(time, timeToAdd);
}
export declare class CustomEvent {
    topics: {};
    hOP: {
        (v: string): boolean;
        (v: PropertyKey): boolean;
    };
    publish(topic: any, info: any): void;
    subscribe(topic: any, listener: any): {
        unsubscribe: () => void;
    };
}
